function [beta,se1,se2]=olshac(y,x,fixk,prewhite,kernel);
% assume the first column of x is a unit vector
% kernel =1 use Parzen
% kernel =2 use QS
% kernel =3 use NW
% fixk=-1 uses Andrews automatic bandwidth selection
% fixk >= 0 uses the user specified bandwidth
% prewhite == 1 does prewhitening

[T,K]=size(x);
beta=inv(x'*x)*x'*y;    % this is the same as beta=x\y
ehat=y-x*beta;
s2=ehat'*ehat/T;        % regression error variance
emat=repmat(ehat,1,K);  % replicate the T by 1 vector K times
gt=x.*emat;             % this is now a T by K matrix
Sxx_i=inv(x'*x/T);
se1=sqrt(diag(Sxx_i*s2/T));   % these are the OLS standard errors
Omega=hac(gt,fixk,prewhite,kernel);
Avar=Sxx_i*Omega*Sxx_i'/T;
se2=sqrt(diag(Avar));         % these are the robust standard errors
