% sets up programs to test multiple correlation coefficients
% uses formulas from Oklin's paper
% program to construct a test for cross section correlation
clear;
warning off;
fixk=1;      % -1 do automatic bandwidth selection  
prewhite=0;  % 0 do not do prewhitening, 1 prewhiten
kernel=2;    % 1 for parzen 2 for QS 3 for NW

doit =2;   % all = 1 do the fisher transformation
in.fmt='%8.3f';
in.width=132;
load -ascii chi2.out;
load -ascii normal.out;
randn('state',999);
rand('state',999);
xlhs=[];
xrhs=[];
r=1;
outfile1='test41.out';
fp=fopen(outfile1,'w');
fclose(fp);
outfile2='test42.out';
fp=fopen(outfile2,'w');
fclose(fp);
outfile3='test43.out';
fp=fopen(outfile3,'w');
fclose(fp);
load absnorm;
grid=(0.05:.01:.95)';




maxit=1000;
mchi=.7979;
vchi=.3634;


XN=[10; 20;20];
XT=[100;100; 200];
XN=[XN;30;30;40];
XT=[XT;200;100;200];

for ixn=1:rows(XN);
  N=XN(ixn);
  T=XT(ixn);
  NN=N*(N-1)/2;
  XID=zeros(NN,3);
XID(:,1)=(1:1:NN)';
cnt=1;
for i=1:N;
  XID(cnt:cnt+N-i-1,2)=i*ones(N-i,1);
  XID(cnt:cnt+N-i-1,3)=(i+1:1:N)';
  cnt=cnt+N-i;
end;

  for model=1:10;
    
store=zeros(maxit,9);
store1=zeros(maxit,9);
store2=zeros(maxit,9);
  for it=1:maxit;
[y,ncorr]=dgp(T,N,r,model);


  sigma=corrcoef(y);
%  store(it,2)=max(mean(abs(sigma)));
%  store1(it,2)=max(mean(abs(sigma)));
  sigma_r=rankcorr(y);
  rm1=[];m1=[];
for i=1:N;
  m1=[m1;sigma(i+1:N,i)];
  rm1=[rm1;sigma_r(i+1:N,i)];
 end; 
 [dum,id_m]=sort(abs(m1),1);
 m1=m1(id_m);
 [dum,id_r]=sort(abs(rm1),1);
 rm1=rm1(id_r);
 [a,b]=ksdensity(m1);
lm1=0.5*(log(1+m1)-log(1-m1));
lrm1=0.5*(log(1+rm1)-log(1-rm1));


ID=XID(id_m,:);
[store(it,:),ym]=dotest(m1,N,T);
[store1(it,:),yrm]=dotest(lm1,N,T);
[store2(it,:),yrm]=dotest(rm1,N,T);


end; % end iteration loop
result =[model N T ncorr mean(store(:,1)) std(store(:,1))];
result =[result   mean(abs(store(:,2:3)) > 1.96)];
result=[result mean(store(:,4)) std(store(:,4)) mean(abs(store(:,5:6))> 1.96) mean(abs(store(:,7:9))>1.96)];

result1 =[model N T ncorr mean(store1(:,1)) std(store1(:,1))];
result1= [result1  mean(abs(store1(:,2:3)) >1.96)];
result1=[result1 mean(store1(:,4)) std(store1(:,4)) mean(abs(store1(:,5:6))> 1.96) mean(abs(store1(:,7:9))>1.96)];

result2 =[model N T ncorr mean(store2(:,1)) std(store2(:,1))];
result2= [result2  mean(abs(store2(:,2:3)) >1.96)];
result2= [result2 mean(store2(:,4)) std(store2(:,4)) mean(abs(store2(:,5:6))> 1.96) mean(abs(store2(:,7:9))>1.96)];

fmt=[repmat('%5d',1,3) repmat('%7.3f',1,12) '\n'];
disp(sprintf(fmt, result));
fp=fopen(outfile1,'a+'); 
in.fid=fp;
in.fmt=fmt;
%mymprint(result,in);
fprintf(fp,fmt,result);
if model==10; fprintf(fp,'\n');end;
fclose(fp);
fp=fopen(outfile2,'a+'); 
in.fid=fp;
in.fmt=fmt;
%mymprint(result1,in);
fprintf(fp,fmt,result1);
if model==10; fprintf(fp,'\n');end;
fclose(fp);  
fp=fopen(outfile3,'a+'); 
in.fid=fp;
in.fmt=fmt;
fprintf(fp,fmt,result2);
if model==10; fprintf(fp,'\n');end;
fclose(fp);
end; % end dgp loop
end; % end N loop
